/*!\file Matice.h
 * \brief: header file for matice object
 */

#ifndef MATICE_H_
#define MATICE_H_

/*Headers:*/
/*{{{1*/
#include "./Material.h"
class IoModel;
/*}}}*/

class Matice: public Material{

	private: 
		int	   mid;
		double B;
		double n;

	public:

		Matice();
		Matice(int mid,double B,double n);
		Matice(int mid,int i, IoModel* iomodel, int num_vertices);
		void Init(int mid,double B,double n);
		~Matice();

		void  Echo();
		void  DeepEcho();
		void  Marshall(char** pmarshalled_dataset);
		int   MarshallSize();
		void  Demarshall(char** pmarshalled_dataset);
		int   Enum();
		int   Id(); 
		int   MyRank();
		void  DistributeNumDofs(int* numdofspernode,int analysis_type);
		void  UpdateFromInputs(void* inputs);
		void  SetB(double B_param);
		void  GetViscosity2d(double* pviscosity, double* pepsilon);
		void  GetViscosity3d(double* pviscosity3d, double* pepsilon);
		void  GetViscosity3dStokes(double* pviscosity3d, double* epsilon);
		void  GetViscosityComplement(double* pviscosity_complement, double* pepsilon);
		Object* copy();
		double GetB();
		double GetN();
		void    UpdateInputsFromVector(double* vector, int name, int type){ISSMERROR("Not implemented yet!");}
		void    UpdateInputsFromConstant(double constant, int name){ISSMERROR("Not implemented yet!");}
		void    UpdateInputsFromConstant(int constant, int name){ISSMERROR("Not implemented yet!");}
		void    UpdateInputsFromConstant(bool constant, int name){ISSMERROR("Not implemented yet!");}

		void    UpdateInputsFromSolution(double* solution, int analysis_type, int sub_analysis_type){ISSMERROR("Not implemented yet!");}


};

#endif  /* _MATICE_H_ */
